/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


int bufclean (BUFFER buf) {
	_r__buffer_type * q=NULL;
	_r__dummy_buffer_type	* p = NULL;
	_r__file_buffer_type	* pf = NULL;
	_r__mem_buffer_type	* pm = NULL;
	_r__cont_buffer_type	* pc = NULL;
	if (!_r__buffer) return 0;
	if (!buf) return 0;
	p = (_r__dummy_buffer_type *) buf;
	p->overflow = 0;
	switch (p->id) {
	case R_NULL_BUFFER: break;
	case R_MEM_BUFFER:
		pm = (_r__mem_buffer_type *) buf;
		while (pm->buffer) {
			q=pm->buffer->next;
			free ((void *) pm->buffer->buf);
			free ((void *) pm->buffer);
			pm->buffer = q; }
		pm->bufferend = NULL;
		pm->len = 0;
		break;
	case R_FILE_BUFFER:
		pf = (_r__file_buffer_type *) buf;
		rewind (pf->f);
		if (ftruncate (fileno(pf->f), (size_t) 0)) return 0;
		pf->len = 0;
		if ((pf->oid != R_FILE_BUFFER) &&
			!(pf->flags & R_BUFFLAG_NO_RECONVERT))
			if (!bufconvert (buf, pf->oid)) return 0;
		break;
	case R_CONT_BUFFER:
		pc = (_r__cont_buffer_type *) buf;
		if (pc->bufferlen != R_BUFFER_PAGE) {
			pc->bufferlen = R_BUFFER_PAGE;
			pc->buffer = realloc (pc->buffer, pc->bufferlen); }
		pc->buffer[0] = 0;
		pc->len = 0;
		break;
	default: return 0; }
	return 1;
}
