/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


int bufclose (BUFFER buf) {
	_r__buffer_type * q=NULL;
	_r__dummy_buffer_type	* p = NULL;
	_r__file_buffer_type	* pf = NULL;
	_r__mem_buffer_type	* pm = NULL;
	_r__cont_buffer_type	* pc = NULL;
	int retval = 1;
	if (!_r__buffer) return 0;
	if (!buf) return 0;
	p = (_r__dummy_buffer_type *) buf;
	if (p->next) ((_r__dummy_buffer_type *) (p->next))->prev = p->prev;
	else	((_r__dummy_buffer_type *) _r__buffer)->prev = p->prev;
	if (buf == _r__buffer) _r__buffer = p->next;
	else 	((_r__dummy_buffer_type *) (p->prev))->next = p->next;
	switch (p->id) {
	case R_NULL_BUFFER: break;
	case R_MEM_BUFFER:
		pm = (_r__mem_buffer_type *) buf;
		while (pm->buffer) {
			q=pm->buffer->next;
			free ((void *) pm->buffer->buf);
			free ((void *) pm->buffer);
			pm->buffer = q; }
		pm->bufferend = NULL;
		pm->len = 0;
		break;
	case R_FILE_BUFFER:
		pf = (_r__file_buffer_type *) buf;
		fclose (pf->f);
		unlink (pf->filename);
		free ((void *) pf->filename);
		pf->len = 0;
		break;
	case R_CONT_BUFFER:
		pc = (_r__cont_buffer_type *) buf;
		free ((void *) pc->buffer);
		pc->bufferlen = 0;
		pc->len = 0;
		break;
	default: retval = 0; }
	p->id = R_NO_BUFFER;
	p->oid = R_NO_BUFFER;
	free (buf);
	return retval;
}



