/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


unsigned int bufevallen (BUFFER buf) {
	_r__buffer_type * q=NULL;
	_r__dummy_buffer_type	* p = NULL;
	_r__file_buffer_type	* pf = NULL;
	_r__null_buffer_type	* pn = NULL;
	_r__mem_buffer_type	* pm = NULL;
	_r__cont_buffer_type	* pc = NULL;
	R_BUFFER_TYPE tid;
	unsigned int i=0;
	if (!_r__buffer) return 0;
	if (!buf) return 0;
	p = (_r__dummy_buffer_type *) buf;
	switch (p->id) {
	case R_NULL_BUFFER: 
		pn = (_r__null_buffer_type *) buf;
		pn->len = 0;
		break;
	case R_MEM_BUFFER:
		pm = (_r__mem_buffer_type *) buf;
		for (q=pm->buffer; q; q=q->next)
			i += strlen (q->buf);
		pm->len = i;
		break;
	case R_CONT_BUFFER:
		pc = (_r__cont_buffer_type *) buf;
		pc->len = strlen (pc->buffer);
		break;
	case R_FILE_BUFFER:
		pf = (_r__file_buffer_type *) buf;
		pf->len = ftell (pf->f);
		break;
	default: return 0; }
	if ((p->flags & R_BUFFLAG_MAXSIZE) &&
		(p->len > p->max_size)) {
		buftrunc (buf, p->max_size);
		p->overflow++; }
	if ((p->flags & R_BUFFLAG_AUTOCONVERT) &&
		(p->len > p->max_mem_size) &&
		(p->id != R_FILE_BUFFER)) {
		tid = p->id;
		bufconvert (buf, R_FILE_BUFFER);
		p->oid = tid; }
	else if ((p->id == R_FILE_BUFFER) &&
		!(p->flags & R_BUFFLAG_NO_RECONVERT) &&
		(p->len <= p->max_mem_size))
		bufconvert (buf, p->oid);
	return p -> len;
}
