/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _REKER_LIB_BUFFER_TYPES_H
#define _REKER_LIB_BUFFER_TYPES_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>
#include <errno.h>
#include "reker.h"


#define R_BUFFER_PAGE 1024
#define R_TMP_FILE "/usr/tmp/buffer.XXXXXX"

typedef struct rbuft {
	char * buf;
	struct rbuft * next;
	} _r__buffer_type;


typedef struct {
	R_BUFFER_TYPE 	id,
			oid;
	unsigned int	flags,
			max_size,
			len,
			max_mem_size;
	int 	overflow;
	void 	* next,
		* prev;
	} _r__dummy_buffer_type;

typedef _r__dummy_buffer_type _r__null_buffer_type;

typedef struct {
	R_BUFFER_TYPE 	id,
			oid;
	unsigned int	flags,
			max_size,
			len,
			max_mem_size;
	int 	overflow;
	void 	* next,
		* prev;
	_r__buffer_type * buffer,
			* bufferend;
	} _r__mem_buffer_type;

typedef struct {
	R_BUFFER_TYPE 	id,
			oid;
	unsigned int	flags,
			max_size,
			len,
			max_mem_size;
	int 	overflow;
	void 	* next,
		* prev;
	char * filename;
	FILE * f;
	} _r__file_buffer_type;

typedef struct {
	R_BUFFER_TYPE 	id,
			oid;
	unsigned int	flags,
			max_size,
			len,
			max_mem_size;
	int 	overflow;
	void 	* next,
		* prev;
	char * buffer;
	unsigned int bufferlen;
	} _r__cont_buffer_type;

extern void * _r__buffer;
extern size_t _r__bt_size;




#endif 

