/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


void * bufgetref (BUFFER buf) {
	if (!_r__buffer) return 0;
	if (!buf) return 0;
	switch (((_r__dummy_buffer_type *) buf) -> id) {
	case R_NULL_BUFFER: 
	case R_MEM_BUFFER: 
	default:
		return NULL;
	case R_CONT_BUFFER: 
		return (void *) &(((_r__cont_buffer_type *) buf) -> buffer);
	case R_FILE_BUFFER:
		return (void *) ((_r__file_buffer_type *) buf) -> f;
	}
}
