/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


char * bufgetstr (BUFFER buf) {
	_r__buffer_type * q=NULL;
	_r__file_buffer_type	* pf = NULL;
	_r__mem_buffer_type	* pm = NULL;
	_r__cont_buffer_type	* pc = NULL;
	int c,j=0;
	char * s;
	if (!_r__buffer) return 0;
	if (!buf) return 0;
	switch (((_r__dummy_buffer_type *) buf) -> id) {
	case R_NULL_BUFFER: 
		s = strdup ("");
		break;
	case R_MEM_BUFFER:
		pm = (_r__mem_buffer_type *) buf;
		s=(char *) malloc ((size_t) pm->len + 1);
		s[0]=0;
		q = pm->buffer;
		while (q) {
			strcat (s, q->buf);
			q=q->next; }
		break;
	case R_FILE_BUFFER:
		pf = (_r__file_buffer_type *) buf;
		s=(char *) malloc ((size_t) pf->len + 1);
		rewind (pf->f);
		while ((c=fgetc(pf->f))!=EOF)
			s[j++]=(unsigned char) c;
		s[j]=0;
		fseek (pf->f, 0, SEEK_END);
		break;
	case R_CONT_BUFFER:
		pc = (_r__cont_buffer_type *) buf;
		s = strdup (pc->buffer);
		break;
	default: s=NULL; }
	return s;
}
