/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


BUFFER bufinit (R_BUFFER_TYPE tid, ...) {
	BUFFER p;
	va_list ap;
	switch (tid) {
	case R_NULL_BUFFER: 
	case R_MEM_BUFFER: 
	case R_CONT_BUFFER: 
		if (!(p=bufopen (tid))) return NULL;
		va_start (ap, tid);
		break;
	case R_FILE_BUFFER: 
		va_start (ap, tid);
		if (!(p=bufopen (tid, va_arg (ap, char*)))) {
			va_end (ap);
			return NULL; }
		break;
	default: return NULL; }
	bufsetflags (p, va_arg (ap, unsigned int));
	bufsetmaxsize (p, va_arg (ap, unsigned int));
	bufsetmaxmemsize (p, va_arg (ap, unsigned int));
	va_end (ap);
	return p;
}
