/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


int bufnprintf (BUFFER buf, unsigned int num, const char * fmt, ...) {
	char * s;
	int retval = 1;
	va_list ap;
	if (!_r__buffer) return 0;
	if (!buf) return 0;
	va_start (ap, fmt);
	s=(char *) malloc ((size_t) num + 1);
	vsnprintf (s, (size_t) num + 1, fmt, ap);
	retval = bufprint (buf, s);
	free ((void *)s);
	va_end (ap);
	return retval;
}
