/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


void * _r__buffer = NULL;
size_t _r__bt_size = 0;



BUFFER bufopen (R_BUFFER_TYPE tid, ...) {
	_r__dummy_buffer_type	* p = NULL;
	_r__mem_buffer_type	* pm = NULL;
	_r__file_buffer_type	* pf = NULL;
	_r__cont_buffer_type	* pc = NULL;
	size_t size = 0;
	va_list ap;
	char 	* s,
		* name;
	if (!_r__bt_size) {
		_r__bt_size = sizeof (_r__null_buffer_type);
		size = sizeof (_r__mem_buffer_type);
		_r__bt_size = (size > _r__bt_size) ? size : _r__bt_size;
		size = sizeof (_r__file_buffer_type);
		_r__bt_size = (size > _r__bt_size) ? size : _r__bt_size;
		size = sizeof (_r__cont_buffer_type);
		_r__bt_size = (size > _r__bt_size) ? size : _r__bt_size;
		_r__bt_size += (_r__bt_size & 3) ? 
				(4 - (_r__bt_size & 3)) : 0; }
	if (!_r__buffer) {
		_r__buffer = malloc(_r__bt_size);
		p = (_r__dummy_buffer_type *) _r__buffer; 
		if (!p) return NULL;
		p->prev = _r__buffer; }
	else	{
		p = (_r__dummy_buffer_type *) (((_r__dummy_buffer_type *) 
			_r__buffer) -> prev);
		p->next = malloc(_r__bt_size);
		if (!p->next) return NULL;
		((_r__dummy_buffer_type *) p->next) -> prev = (void *) p;
		p = (_r__dummy_buffer_type *) p->next; }
	((_r__dummy_buffer_type *) _r__buffer) -> prev = (void *) p;
	p->next = NULL;
	p->len = 0;
	p->max_size = 0;
	p->max_mem_size = 0;
	p->flags = 0;
	p->overflow = 0;
	p->id = tid;
	p->oid = tid;
	switch (tid) {
	case R_NULL_BUFFER: 
		break;
	case R_MEM_BUFFER:
		pm = (_r__mem_buffer_type *) p;
		pm->buffer = NULL;
		pm->bufferend = NULL;
		pm = NULL;
		break;
	case R_FILE_BUFFER:
		pf = (_r__file_buffer_type *) p;
		va_start (ap, tid);
		name = va_arg (ap, char*);
		if (!name || !strlen (name)) {
			s=strdup (R_TMP_FILE);
			mktemp (s); }
		else	s=strdup (name);
		va_end (ap);
		name = NULL;
		pf->filename = s;
		pf->f = fopen (s, "w+");
		s = NULL;
		if (!pf->f) {
			if (pf->filename) free(pf->filename);
			pf->filename = NULL;
			pf->id = R_NULL_BUFFER;
			bufclose ((void *) pf);
			p = NULL; }
		pf = NULL;
		break;
	case R_CONT_BUFFER:
		pc = (_r__cont_buffer_type *) p;
		pc->buffer = (char *) malloc ((size_t) R_BUFFER_PAGE);
		pc->buffer[0] = 0;
		pc->bufferlen = R_BUFFER_PAGE;
		pc = NULL;
		break;
	default:
		p->id = R_NULL_BUFFER;
		bufclose (p);
		p = NULL;
		break;
	}
	return (void *) p;
}
