/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


int bufprint (BUFFER buf, const char * str) {
	_r__dummy_buffer_type	* p = NULL;
	_r__mem_buffer_type	* pm = NULL;
	_r__file_buffer_type	* pf = NULL;
	_r__cont_buffer_type	* pc = NULL;
	_r__buffer_type		* q;
	int retval = 1;
	char * s;
	if (!_r__buffer) return 0;
	if (!buf) return 0;
	p = (_r__dummy_buffer_type *) buf;
	if ((p->flags & R_BUFFLAG_MAXSIZE) &&
		(p->max_size < (p->len + strlen(str)))) {
		s = (char *) malloc ((size_t) p->max_size - p->len + 1);
		strncpy (s, str, p->max_size - p->len);
		s [p->max_size - p->len] = 0; 
		retval = 0; 
		p->overflow++; }
	else	s = strdup (str);
	if (!strlen (s)) return retval;
	switch (p->id) {
	case R_NULL_BUFFER: break;
	case R_MEM_BUFFER:
		pm = (_r__mem_buffer_type *) buf;
		if ((pm->flags & R_BUFFLAG_AUTOCONVERT) &&
			((pm->len + strlen (s)) > pm->max_mem_size)) {
			if (!bufconvert (buf, R_FILE_BUFFER)) goto cleanup;
			pm->oid = R_MEM_BUFFER;
			goto jump_in_1; 
			break; }
		if (!pm->buffer) {
			pm->buffer = (_r__buffer_type *) 
				malloc(sizeof(_r__buffer_type));
			q = pm->buffer; }
		else	{
			q = pm->bufferend;
			q->next = (_r__buffer_type *) 
				malloc(sizeof(_r__buffer_type));
			q = q->next; }
		q->next = NULL;
		q->buf = strdup (s);
		pm->len += strlen (s);
		pm->bufferend = q;
		break;
	case R_FILE_BUFFER:
jump_in_1:	pf = (_r__file_buffer_type *) buf;
		fprintf (pf->f, "%s", s);
		pf->len += strlen(s);
		break;
	case R_CONT_BUFFER:
		pc = (_r__cont_buffer_type *) buf;
		if ((pc->flags & R_BUFFLAG_AUTOCONVERT) &&
			((pc->len + strlen (s)) > pc->max_mem_size)) {
			if (!bufconvert (buf, R_FILE_BUFFER)) goto cleanup;
			pc->oid = R_CONT_BUFFER;
			goto jump_in_1; 
			break; }
		pc->len += strlen (s);
		if ((pc->len + 1) > pc->bufferlen) {
		    if (pc->flags & R_BUFFLAG_GROW_FAST)
			while (pc->bufferlen < (pc->len + 1))
				pc->bufferlen *= 2;
		    else pc->bufferlen = ((pc->len + 1) / R_BUFFER_PAGE) *
				R_BUFFER_PAGE + R_BUFFER_PAGE;
		    pc->buffer = realloc (pc->buffer, pc->bufferlen); }
		strcat (pc->buffer, s);
		break;
	default: goto cleanup; }
	free ((void *) s);
	return retval;
cleanup: 
	free ((void *) s);
	return 0;
}


