/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


int bufprintout (BUFFER buf, FILE * f) {
	_r__buffer_type * q=NULL;
	_r__dummy_buffer_type	* p = NULL;
	_r__file_buffer_type	* pf = NULL;
	_r__mem_buffer_type	* pm = NULL;
	_r__cont_buffer_type	* pc = NULL;
	int c;
	if (!_r__buffer) return 0;
	if (!buf) return 0;
	p = (_r__dummy_buffer_type *) buf;
	switch (p->id) {
	case R_NULL_BUFFER: break;
	case R_MEM_BUFFER:
		pm = (_r__mem_buffer_type *) buf;
		q=pm->buffer;
		while (q) {
			fprintf (f, "%s", q->buf);
			q=q->next; }
		break;
	case R_FILE_BUFFER:
		pf = (_r__file_buffer_type *) buf;
		rewind (pf->f);
		while ((c=fgetc(pf->f))!=EOF)
			fprintf (f, "%c", (unsigned char) c);
		fseek (pf->f, 0, SEEK_END);
		break;
	case R_CONT_BUFFER:
		pc = (_r__cont_buffer_type *) buf;
		fprintf (f, "%s", pc->buffer);
		break;
	default: return 0; }
	return 1;
}
