/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


int bufputstr (BUFFER buf, char * s) {
	_r__buffer_type * q=NULL;
	_r__mem_buffer_type	* pm = NULL;
	if (!_r__buffer) return 0;
	if (!buf) return 0;
	if (!s) return 0;
	switch (((_r__dummy_buffer_type *) buf) -> id) {
	case R_NULL_BUFFER: 
		free (s);
		break;
	case R_MEM_BUFFER:
		pm = (_r__mem_buffer_type *) buf;
		if ((pm->flags & R_BUFFLAG_MAXSIZE) &&
			(pm->max_size < (strlen (s) + pm->len))) {
			s = realloc (s, (size_t) pm->max_size - pm->len + 1);
			s[pm->max_size - pm->len] = 0;
			pm->overflow++; }
		if (strlen(s) == 0) {
			free (s);
			break; }
		if ((pm->flags & R_BUFFLAG_AUTOCONVERT) &&
			((pm->len + strlen (s)) > pm->max_mem_size)) {
			if (!bufconvert (buf, R_FILE_BUFFER)) return 0;
			pm->oid = R_MEM_BUFFER;
			bufprint (buf, s); 
			free (s); 
			break; }
		if (!pm->buffer) {
			pm->buffer = (_r__buffer_type *) 
				malloc(sizeof(_r__buffer_type));
			q = pm->buffer; }
		else	{
			q = pm->bufferend;
			q->next = (_r__buffer_type *) 
				malloc(sizeof(_r__buffer_type));
			q = q->next; }
		q->next = NULL;
		q->buf = s;
		pm->len += strlen (s);
		pm->bufferend = q;
		break;
	case R_FILE_BUFFER:
	case R_CONT_BUFFER:
		bufprint (buf, s);
		free (s);
		break;
	default:
		free (s);
		return 0; }
	return 1;
}	


