/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


int bufunsetflags (BUFFER buf, unsigned int _flags) {
	_r__dummy_buffer_type * p;
	if (!_r__buffer) return 0;
	if (!buf) return 0;
	p = (_r__dummy_buffer_type *) buf;
	switch (p->id) {
	case R_NULL_BUFFER: break;
	case R_MEM_BUFFER: break;
	case R_FILE_BUFFER: break;
	case R_CONT_BUFFER: break;
	default: return 0; }
	p->flags &= ~_flags;
	if ((_flags & R_BUFFLAG_AUTOCONVERT) && 
		!(p->flags & R_BUFFLAG_NO_RECONVERT)
		&& (p->id == R_FILE_BUFFER) && (p->oid != R_FILE_BUFFER) )
		bufconvert (buf, p->oid);
	return 1;
}
