/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "reker.h"
#include "buffer_types.h"


int bufvlprintf (BUFFER buf, const char * fmt, va_list ap) {
	BUFFER help;
	_r__file_buffer_type	* pf = NULL;
	int retval = 1;
	if (!_r__buffer) return 0;
	if (!buf) return 0;
	switch (((_r__dummy_buffer_type *) buf) -> id) {
	case R_NULL_BUFFER: break;
	case R_FILE_BUFFER:
		pf = (_r__file_buffer_type *) buf;
		vfprintf (pf->f, fmt, ap);
		pf->len = ftell (pf->f);
		if ((pf->flags & R_BUFFLAG_MAXSIZE) &&
			(pf->len > pf->max_size)) {
			pf->len = pf->max_size;
			rewind (pf->f);
			ftruncate (fileno (pf->f), (size_t) pf->len);
			fseek (pf->f, 0, SEEK_END); 
			pf->overflow++; }
		break;
	case R_MEM_BUFFER:
	case R_CONT_BUFFER:
		help=bufopen (R_FILE_BUFFER, NULL);
		retval *= bufvlprintf (help, fmt, ap);
		retval *= bufmv (buf, help);
		retval *= bufclose (help);
		break;
	default: retval=0; }
	return retval;
}
