/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>


/**************************************************************************
 * 		reverse the bits in a 32 bit word			  *
 **************************************************************************/

long reverse_bits (register long n) {
        n = ((n >>  1) & 0x55555555) | ((n <<  1) & 0xaaaaaaaa);
        n = ((n >>  2) & 0x33333333) | ((n <<  2) & 0xcccccccc);
        n = ((n >>  4) & 0x0f0f0f0f) | ((n <<  4) & 0xf0f0f0f0);
        n = ((n >>  8) & 0x00ff00ff) | ((n <<  8) & 0xff00ff00);
        n = ((n >> 16) & 0x0000ffff) | ((n << 16) & 0xffff0000);
	return n;
}


/*
 * reverse the bits in a 16 bit word
 */

short reverse_bits16 (register short n) {
        n = ((n >>  1) & 0x5555) | ((n <<  1) & 0xaaaa);
        n = ((n >>  2) & 0x3333) | ((n <<  2) & 0xcccc);
        n = ((n >>  4) & 0x0f0f) | ((n <<  4) & 0xf0f0);
        n = ((n >>  8) & 0x00ff) | ((n <<  8) & 0xff00);
	return n;
}


/*
 * reverse the bits in a 8 bit word
 */

char reverse_bits8 (register char n) {
        n = ((n >>  1) & 0x55) | ((n <<  1) & 0xaa);
        n = ((n >>  2) & 0x33) | ((n <<  2) & 0xcc);
        n = ((n >>  4) & 0x0f) | ((n <<  4) & 0xf0);
	return n;
}



