/*
 *   This is part of the Reker - Library.
 *   Copyright (C) 1999  Frank Reker <frank@reker.net>
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "reker.h"


#define R_BUFFER_PAGE 256


/*****************************************************************************
 *	fstrscan reads one line from allready open file f (filediscriptor)   *
 *	the terminating newline character is replaced with a NULL char	     *
 *	NULL chars in the string are not filtered out, but terminate the     *
 *	string.								     *
 *	The string size is evaluated and allocated while reading and 	     *
 *	a pointer to this string is returned				     *
 *****************************************************************************/


char * fstrscan (FILE * f) {
	BUFFER buf;
	int c;
	char * s;
	buf = bufopen (R_CONT_BUFFER);
	bufsetmaxsize (buf, 0x40000000); /* maxsize = 1GB */
	bufsetmaxmemsize (buf, 0x200000); /* max mem size = 2MB */
	bufsetflags (buf, R_BUFFLAG_MAXSIZE | R_BUFFLAG_AUTOCONVERT);
	while ((c = fgetc(f)) != EOF) 
		if (c == '\n') break;
		else bufprintf (buf, "%c", (unsigned char) c);
	s = bufgetstr (buf);
	bufclose (buf);
	return s;
}
	




/****************************************************************************
 *	strscan - works like fstrscan, but reads from stdin		    *
 ****************************************************************************/


char * strscan () {
	return fstrscan (stdin);
}







